Index: /trunk/AddOn/TAcq/README
===================================================================
--- /trunk/AddOn/TAcq/README	(revision 3657)
+++ /trunk/AddOn/TAcq/README	(revision 3658)
@@ -6,4 +6,5 @@
    Module CVSSophya/AddOn/TAcq
 ###########################################################
+####### VOIR HISTORIQUE DES MODIFS a la fin (points 6,7...)
 
 1/ programmes de test debit I/O disque
@@ -58,2 +59,8 @@
      minifits acquisition 
      Ajout fichiers : mcrd.cc , brfitsrd.h .cc , brproc.h .cc  
+
+7/ --- Septembre/Octobre 2009
+   o Ajout possibilite de creation de spectre temps-frequence ds mcrd
+   o Amelioration de la classe RAcqMemZoneMgr pour la gestion multi-fibres (donnees
+     de plusieurs fibres dans un meme objet RAcqMemZoneMgr
+   o Amelioration de la classe MiniFITSFile pour permettre l'ajout d'information ds l'entete FITS
Index: /trunk/AddOn/TAcq/brpaqu.cc
===================================================================
--- /trunk/AddOn/TAcq/brpaqu.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/brpaqu.cc	(revision 3658)
@@ -14,5 +14,5 @@
 
 /* --Methode__ */
-BRPaquet::BRPaquet(Byte* src, Byte* dst, int paqsz, BRDataFmtConv fgswap)
+BRPaquet::BRPaquet(Byte* src, Byte* dst, int paqsz, BRDataFmtConv fgswap,int binMin,int nbBin )
   // swapall = true -> on swap tout le paquet, sinon swap entete seulement
 {
@@ -24,5 +24,6 @@
   UInt32* src32 = (UInt32*)src;
   UInt32* dst32 = (UInt32*)dst;
-
+  Byte* tmp = new Byte[sz_];
+ 
   switch ( fgswap ) {
   case BR_DoNothing :  // rien a faire
@@ -31,4 +32,14 @@
     memcpy(dst_, src, sz_); 
     break;
+  case BR_Copy_Reduc : // copie directe 
+   memcpy(dst_, src, HeaderSize()); 
+   
+    memcpy(dst_+ HeaderSize(), src+(binMin+ HeaderSize()), nbBin); 
+   memcpy(dst_+ (HeaderSize()+ nbBin ), src+(binMin+ HeaderSize()+sz_/2), nbBin); 
+   memcpy(dst_+( HeaderSize()+( 2* nbBin)),src+(HeaderSize()+DataSize()),TrailerSize());
+ 
+    SetPaqLen( nbBin/2);
+   break;
+   
   case BR_Swap32 : // On swappe toutes les donnees du paquet 
   //  les bytes sont dans l'ordre par paquet de 4 octets (Int32) , les deux Int32 de 
@@ -37,6 +48,5 @@
       dst32[ka] = src32[ka+1];
       dst32[ka+1] = src32[ka];
-    }
-   
+    }   
     break;
   case BR_SwapAll:
@@ -47,5 +57,5 @@
       }
     }
-    for(int ka=HeaderSize()+DataSize(); ka<sz_; ka+=8) {
+  for(int ka=HeaderSize()+DataSize(); ka<sz_; ka+=8) {
       for(int kb=0; kb<4; kb++) {
 	dst_[ka+kb] = src[ka+3-kb+4];    
@@ -100,5 +110,5 @@
       dst32[ka+1] = src32[ka];
     }
-    
+    break;
   case BR_FFTOneChanNoSwap :
   case BR_FFTTwoChanNoSwap :
@@ -117,6 +127,34 @@
     // copie du trailler uniquement : 
      for(int ka=(HeaderSize()+DataSize())/4;ka < sz_/4; ka++)  dst32[ka] = src32[ka];
+     break;
+  case BR_CpHdrTrl :
+    for(int ka=0; ka<BRHDRSIZE/4; ka++)  dst32[ka] = src32[ka];
+    for(int ka=(HeaderSize()+DataSize())/4;ka < sz_/4; ka++)  dst32[ka] = src32[ka];
+    break;
+
+ case BR_FFTOneChanNoSwapReduct :
+  case BR_FFTTwoChanNoSwapReduct :
+    // copie du header uniquement 
    
-    break;
+    for(int ka=0; ka<BRHDRSIZE/4; ka++)  dst32[ka] = src32[ka];
+
+    //DEL  on a plus de swapdonc il faut copier dans dst
+    //DEL    memcpy(dst_, src, sz_); 
+
+    // on reoordonne les coeff FFT (pas de swap) 
+    if (fgswap == BR_FFTOneChanNoSwap) ReorderFFTDataNoSwap(src+HeaderSize(), tmp+HeaderSize(), DataSize());
+    else if (fgswap == BR_FFTTwoChanNoSwap) {
+      ReorderFFTDataNoSwap(src+HeaderSize(), tmp+HeaderSize(), DataSize()/2);
+      ReorderFFTDataNoSwap(src+HeaderSize()+DataSize()/2, tmp+HeaderSize()+DataSize()/2, DataSize()/2);
+    }
+    memcpy(tmp+ HeaderSize(), src+(binMin+ HeaderSize()), nbBin); 
+   memcpy(tmp+ (HeaderSize()+ nbBin ), src+(binMin+ HeaderSize()+sz_/2), nbBin); 
+   memcpy(tmp+( HeaderSize()+( 2* nbBin)),src+(HeaderSize()+DataSize()),TrailerSize());
+   memcpy(dst_+ HeaderSize(),tmp+ HeaderSize(),( 2* nbBin)+TrailerSize());
+    SetPaqLen( nbBin/2);
+
+    // copie du trailler uniquement : 
+    //  for(int ka=(HeaderSize()+DataSize())/4;ka < sz_/4; ka++)  dst32[ka] = src32[ka];
+     break;
   }  // Fin switch 
 
Index: /trunk/AddOn/TAcq/brpaqu.h
===================================================================
--- /trunk/AddOn/TAcq/brpaqu.h	(revision 3657)
+++ /trunk/AddOn/TAcq/brpaqu.h	(revision 3658)
@@ -99,5 +99,9 @@
   BR_FFTTwoChan32,
   BR_FFTOneChanNoSwap,
-  BR_FFTTwoChanNoSwap
+  BR_FFTTwoChanNoSwap,
+  BR_CpHdrTrl,
+  BR_Copy_Reduc,
+  BR_FFTOneChanNoSwapReduct,
+  BR_FFTTwoChanNoSwapReduct
 };
 
@@ -106,8 +110,8 @@
  public:
 // Cree d'un objet BRPaquet avec copie/swap depuis src -> dst (si src != NULL)
-  BRPaquet(Byte* src, Byte* dst, int paqsz=4096, BRDataFmtConv fgswap=BR_SwapAll);
-// Cree d'un objet BRPaquet de taille paqsz sur la zone dst   
-  BRPaquet(Byte* srcdst, int paqsz=4096);
-//  ~BRPaquet();
+  BRPaquet(Byte* src, Byte* dst, int paqsz=16424, BRDataFmtConv fgswap=BR_Copy,int minBin=0,int nbBin=0);
+  // Cree d'un objet BRPaquet de taille paqsz sur la zone dst   
+  BRPaquet(Byte* srcdst, int paqsz=16424);
+  //  ~BRPaquet();
 
   // Acces diverses tailles 
@@ -171,4 +175,5 @@
   int sz_; //taille du paquet 
   Byte* dst_;  
+  
 };
 
Index: /trunk/AddOn/TAcq/brproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brproc.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/brproc.cc	(revision 3658)
@@ -151,4 +151,8 @@
     uint_8 firsttt=0;
     bool fgfirst=true;
+    double moysig[2]={0.,0.};
+    double sigsig[2]={0.,0.};
+    uint_8 nbsig[2]={0,0};
+
     for (uint_4 kmz=0; kmz<nmax_; kmz++) {
       if (stop_) break;
@@ -176,4 +180,7 @@
             r_4 vts=(r_4)(*(paq.Data1()+j));
             h1.Add((r_8)vts);
+            moysig[0] += (double)vts;
+            sigsig[0] += ((double)vts)*((double)vts);
+            nbsig[0]++;
   	    vx(j) = vts-127.5;
           }
@@ -201,4 +208,7 @@
             r_4 vts=(r_4)(*(paq.Data2()+j));
             h2.Add((r_8)vts);
+            moysig[1] += (double)vts;
+            sigsig[1] += ((double)vts)*((double)vts);
+            nbsig[1]++;
   	    vx(j) = vts-127.5;
           }
@@ -306,5 +316,31 @@
           po << PPFNameTag(tagh1) << h1; 
           po << PPFNameTag(tagh2) << h2; 
-        }
+
+          double sspvmax[3] = {0.,0.,0.};
+	  int_4 sspvmaxidx[3] = {-1,-1,-1};
+	  for(int jji=1;jji<visiV12.Size()-1;jji++) {
+            r_4 zmv2 = Zmod2(visiV12(jji)); 
+	    if (zmv2>sspvmax[2]) { sspvmax[2]=zmv2; sspvmaxidx[2]=jji; }
+	  }
+          TVector<r_4>& sspv = spectreV1;
+          for(int ic=0; ic<2; ic++) {
+            if (ic==1) sspv = spectreV2;
+            for(int jji=1;jji<sspv.Size()-1;jji++) 
+              if (sspv(jji)>sspvmax[ic]) { sspvmax[ic]=sspv(jji); sspvmaxidx[ic]=jji; }
+            if (nbsig[ic] < 1) { moysig[ic]=sigsig[ic]=-1.;  }
+            else {
+              moysig[ic] /= (double)nbsig[ic];
+              sigsig[ic] /= (double)nbsig[ic];
+              sigsig[ic] -= (moysig[ic]*moysig[ic]);
+              sigsig[ic] = sqrt(sigsig[ic]);
+              cout << "===Voie " << ic << " Moy=" << moysig[ic] << " Sig=" << sigsig[ic]
+                   << " MaxSpec Amp= " << sqrt(sspvmax[ic])/double(pq.DataSize()/2/2) 
+		   << " Pos=" << sspvmaxidx[ic] << "  (NPts=" << nbsig[ic] << ")" << endl;
+	    }
+	  }
+	  cout << "=== Voie1x2 MaxSpec Amp= " << sqrt(sqrt(sspvmax[2])/double(pq.DataSize()/2/2))
+	       << " Pos=" << sspvmaxidx[2] << endl;
+        }  // fin if (fghist_)
+
         if (fgtimfreq) {
           timfreqV1 /= (r_4)nzm;
@@ -320,4 +356,7 @@
           h1.Zero();
           h2.Zero();
+          moysig[0]=moysig[1]=0.;
+          sigsig[0]=sigsig[1]=0.;
+          nbsig[0]=nbsig[1]=0;
         }
         if (fgtimfreq) {
Index: /trunk/AddOn/TAcq/makefile
===================================================================
--- /trunk/AddOn/TAcq/makefile	(revision 3657)
+++ /trunk/AddOn/TAcq/makefile	(revision 3658)
@@ -1,123 +1,166 @@
 include $(SOPHYABASE)/include/sophyamake.inc
+
+OBJ = ./Objs/
+EXE = ./Objs/
 
 # all : traidio  tmtfft tstminifits tbrpaq tpciew tmtacq tstrdfits mfits2spec tsok 
 # all : traidio  tmtfft tstminifits tmtacq tstrdfits mfits2spec tsok mcrd
-all : traidio tstminifits tmtacq mfits2spec mcrd svv2mtx 
+all : traidio tstminifits tmtacq mfits2spec mcrd svv2mtx tsok
 
 clean :
+	rm -f $(OBJ)*.o $(EXE)*
+
+cleanold :
 	rm -f *.o traidio tmtfft tstminifits tpciew tbrpaq tmtacq tstrdfits mfits2spec mcrd svv2mtx
-	rm -f mfits2spec tsok *.ppf *.fits 
+	rm -f Objs/* *.ppf *.fits 
 
 ########################################################
 
 ##   --------------
-tmtacq : tmtacq.o  racqumem.o racqurw.o racquproc.o brpaqu.o pciewrap.o minifits.o
-	$(CXXLINK) -o tmtacq tmtacq.o  racqumem.o racqurw.o racquproc.o brpaqu.o pciewrap.o minifits.o $(SOPHYAALLSLBLIST)
+tmtacq : $(EXE)tmtacq
+	echo '---tmtacq made'
 
-tmtacq.o : tmtacq.cc racquproc.h racqurw.h racqumem.h
-	$(CXXCOMPILE) -c -DNOPCIECARD -o tmtacq.o tmtacq.cc 
+$(EXE)tmtacq : $(OBJ)tmtacq.o  $(OBJ)racqumem.o $(OBJ)racqurw.o $(OBJ)racquproc.o \
+               $(OBJ)brpaqu.o $(OBJ)pciewrap.o $(OBJ)minifits.o
+	$(CXXLINK) -o $(EXE)tmtacq $(OBJ)tmtacq.o $(OBJ)racqumem.o $(OBJ)racqurw.o $(OBJ)racquproc.o \
+                      $(OBJ)brpaqu.o $(OBJ)pciewrap.o $(OBJ)minifits.o $(SOPHYAALLSLBLIST)
 
-racqumem.o : racqumem.cc racqumem.h
-	$(CXXCOMPILE) -c -o racqumem.o racqumem.cc 
+$(OBJ)tmtacq.o : tmtacq.cc racquproc.h racqurw.h racqumem.h brpaqu.h
+	$(CXXCOMPILE) -c -DNOPCIECARD -o $(OBJ)tmtacq.o tmtacq.cc 
 
-racqurw.o : racqurw.cc racqurw.h racqumem.h
-	$(CXXCOMPILE) -c -o racqurw.o racqurw.cc 
+$(OBJ)racqumem.o : racqumem.cc racqumem.h
+	$(CXXCOMPILE) -c -o $(OBJ)racqumem.o racqumem.cc 
 
-racquproc.o : racquproc.cc racquproc.h racqurw.h racqumem.h
-	$(CXXCOMPILE) -c -o racquproc.o racquproc.cc 
+$(OBJ)racqurw.o : racqurw.cc racqurw.h racqumem.h brpaqu.h
+	$(CXXCOMPILE) -c -o $(OBJ)racqurw.o racqurw.cc 
+
+$(OBJ)racquproc.o : racquproc.cc racquproc.h racqurw.h racqumem.h brpaqu.h
+	$(CXXCOMPILE) -c -o $(OBJ)racquproc.o racquproc.cc 
 
 ## Lecture / traitement minifits multi-thread
 ##   --------------
-mcrd : mcrd.o  racqumem.o brfitsrd.o brproc.o racquproc.o brpaqu.o racqurw.o pciewrap.o minifits.o
-	$(CXXLINK) -o mcrd mcrd.o  racqumem.o brfitsrd.o brproc.o racquproc.o brpaqu.o racqurw.o pciewrap.o minifits.o $(SOPHYAALLSLBLIST)
+mcrd : $(EXE)mcrd
+	echo '---mcrd made'
 
-mcrd.o : mcrd.cc brfitsrd.h racqumem.h brproc.h racqurw.h
-	$(CXXCOMPILE) -c  -o mcrd.o mcrd.cc 
+$(EXE)mcrd : $(OBJ)mcrd.o  $(OBJ)racqumem.o $(OBJ)brfitsrd.o $(OBJ)brproc.o $(OBJ)racquproc.o $(OBJ)brpaqu.o \
+             $(OBJ)racqurw.o $(OBJ)pciewrap.o $(OBJ)minifits.o
+	$(CXXLINK) -o $(EXE)mcrd $(OBJ)mcrd.o $(OBJ)racqumem.o $(OBJ)brfitsrd.o $(OBJ)brproc.o $(OBJ)racquproc.o \
+                      $(OBJ)brpaqu.o $(OBJ)racqurw.o $(OBJ)pciewrap.o $(OBJ)minifits.o $(SOPHYAALLSLBLIST)
 
-brfitsrd.o : brfitsrd.cc brfitsrd.h racqumem.h
-	$(CXXCOMPILE) -c -o brfitsrd.o brfitsrd.cc 
+$(OBJ)mcrd.o : mcrd.cc brfitsrd.h racqumem.h brproc.h racqurw.h
+	$(CXXCOMPILE) -c  -o $(OBJ)mcrd.o mcrd.cc 
 
-brproc.o : brproc.cc brproc.h racqumem.h
-	$(CXXCOMPILE) -c  -o brproc.o brproc.cc 
+$(OBJ)brfitsrd.o : brfitsrd.cc brfitsrd.h racqumem.h brpaqu.h
+	$(CXXCOMPILE) -c -o $(OBJ)brfitsrd.o brfitsrd.cc 
+
+$(OBJ)brproc.o : brproc.cc brproc.h racqumem.h brpaqu.h
+	$(CXXCOMPILE) -c  -o $(OBJ)brproc.o brproc.cc 
 
 ##   --------------
-svv2mtx : svv2mtx.o 
-	$(CXXLINK) -o svv2mtx svv2mtx.o  $(SOPHYAEXTSLBLIST)
+svv2mtx : $(EXE)svv2mtx
+	echo '---svv2mtx made'
 
-svv2mtx.o : svv2mtx.cc 
-	$(CXXCOMPILE) -o svv2mtx.o svv2mtx.cc
+$(EXE)svv2mtx : $(OBJ)svv2mtx.o 
+	$(CXXLINK) -o $(EXE)svv2mtx $(OBJ)svv2mtx.o  $(SOPHYAEXTSLBLIST)
+
+$(OBJ)svv2mtx.o : svv2mtx.cc 
+	$(CXXCOMPILE) -o $(OBJ)svv2mtx.o svv2mtx.cc
 
 ##   --------------
-tbrpaq : tbrpaq.o brpaqu.o racqumem.o racqurw.o racquproc.o  
-	$(CXXLINK) -o tbrpaq tbrpaq.o brpaqu.o  $(SOPHYAALLSLBLIST)
+tbrpaq : $(EXE)tbrpaq
+	echo '---tbrpaq made'
 
-tbrpaq.o : tbrpaq.cc brpaqu.h
-	$(CXXCOMPILE) -c -o tbrpaq.o tbrpaq.cc 
+$(EXE)tbrpaq : $(OBJ)tbrpaq.o $(OBJ)brpaqu.o 
+	$(CXXLINK) -o $(EXE)tbrpaq $(OBJ)tbrpaq.o $(OBJ)brpaqu.o  $(SOPHYAALLSLBLIST)
 
-brpaqu.o : brpaqu.cc brpaqu.h
-	$(CXXCOMPILE) -c -o brpaqu.o brpaqu.cc 
+$(OBJ)tbrpaq.o : tbrpaq.cc brpaqu.h
+	$(CXXCOMPILE) -c -o $(OBJ)tbrpaq.o tbrpaq.cc 
+
+$(OBJ)brpaqu.o : brpaqu.cc brpaqu.h
+	$(CXXCOMPILE) -c -o $(OBJ)brpaqu.o brpaqu.cc 
 
 ##   --------------
-tpciew : tpciew.o pciewrap.o
-	$(CXXLINK) -o tpciew  tpciew.o pciewrap.o $(SOPHYAEXTSLBLIST)
+tpciew : $(EXE)tpciew
+	echo '---tpciew made'
 
-tpciew.o : tpciew.cc pciewrap.h
-	$(CXXCOMPILE) -o tpciew.o tpciew.cc
+$(EXE)tpciew : $(OBJ)tpciew.o $(OBJ)pciewrap.o
+	$(CXXLINK) -o $(EXE)tpciew  $(OBJ)tpciew.o $(OBJ)pciewrap.o $(SOPHYAEXTSLBLIST)
 
-pciewrap.o : pciewrap.cc pciewrap.h
-	$(CXXCOMPILE) -o pciewrap.o pciewrap.cc
+$(OBJ)tpciew.o : tpciew.cc pciewrap.h
+	$(CXXCOMPILE) -o $(OBJ)tpciew.o tpciew.cc
 
-##   --------------
+$(OBJ)pciewrap.o : pciewrap.cc pciewrap.h
+	$(CXXCOMPILE) -o $(OBJ)pciewrap.o pciewrap.cc
 
-mfits2spec : mfits2spec.o minifits.o brpaqu.o 
-	$(CXXLINK) -o mfits2spec mfits2spec.o minifits.o brpaqu.o $(SOPHYAEXTSLBLIST)
+##   --------------  Lecture minifits et calcul de spectre 
+mfits2spec : $(EXE)mfits2spec
+	echo '---mfits2spec made'
 
-mfits2spec.o : mfits2spec.cc minifits.h brpaqu.h 
-	$(CXXCOMPILE) -o mfits2spec.o mfits2spec.cc
+$(EXE)mfits2spec : $(OBJ)mfits2spec.o $(OBJ)minifits.o $(OBJ)brpaqu.o 
+	$(CXXLINK) -o $(EXE)mfits2spec $(OBJ)mfits2spec.o $(OBJ)minifits.o $(OBJ)brpaqu.o $(SOPHYAEXTSLBLIST)
 
-tstrdfits : tstrdfits.o minifits.o
-	$(CXXLINK) -o tstrdfits tstrdfits.o minifits.o  $(SOPHYAEXTSLBLIST)
+$(OBJ)mfits2spec.o : mfits2spec.cc minifits.h brpaqu.h 
+	$(CXXCOMPILE) -o $(OBJ)mfits2spec.o mfits2spec.cc
 
-tstrdfits.o : tstrdfits.cc minifits.h
-	$(CXXCOMPILE) -o tstrdfits.o tstrdfits.cc
+##   --------------  Tests minifits 
+tstrdfits : $(EXE)tstrdfits
+	echo '---tstrdfits made'
 
-tstminifits : tstminifits.o minifits.o
-	$(CXXLINK) -o tstminifits tstminifits.o minifits.o  $(SOPHYAEXTSLBLIST)
+$(EXE)tstrdfits : $(OBJ)tstrdfits.o $(OBJ)minifits.o
+	$(CXXLINK) -o tstrdfits $(OBJ)tstrdfits.o $(OBJ)minifits.o  $(SOPHYAEXTSLBLIST)
 
-tstminifits.o : tstminifits.cc minifits.h
-	$(CXXCOMPILE) -o tstminifits.o tstminifits.cc
+$(OBJ)tstrdfits.o : tstrdfits.cc minifits.h
+	$(CXXCOMPILE) -o $(OBJ)tstrdfits.o tstrdfits.cc
 
-minifits.o : minifits.cc minifits.h
-	$(CXXCOMPILE) -o minifits.o minifits.cc
+tstminifits : $(EXE)tstminifits
+	echo '---tstrdfits made'
 
-##   --------------
-traidio : traidio.o 
-	$(CXXLINK) -o traidio traidio.o $(SOPHYAEXTSLBLIST)
+$(EXE)tstminifits : $(OBJ)tstminifits.o $(OBJ)minifits.o
+	$(CXXLINK) -o $(EXE)tstminifits $(OBJ)tstminifits.o $(OBJ)minifits.o  $(SOPHYAEXTSLBLIST)
 
-traidio.o : traidio.cc
-	$(CXXCOMPILE) -o traidio.o traidio.cc
+$(OBJ)tstminifits.o : tstminifits.cc minifits.h
+	$(CXXCOMPILE) -o $(OBJ)tstminifits.o tstminifits.cc
 
-tmtfft : tmtfft.o 
-	$(CXXLINK) -o tmtfft tmtfft.o $(SOPHYAEXTSLBLIST)
+$(OBJ)minifits.o : minifits.cc minifits.h
+	$(CXXCOMPILE) -o $(OBJ)minifits.o minifits.cc
 
-tmtfft.o : tmtfft.cc
-	$(CXXCOMPILE) -o tmtfft.o tmtfft.cc
+##   -------------- Tests performances I/O et FFT multi-threads
+traidio : $(EXE)traidio
+	echo '---traidio made'
+
+$(EXE)traidio : $(OBJ)traidio.o 
+	$(CXXLINK) -o $(EXE)traidio $(OBJ)traidio.o $(SOPHYAEXTSLBLIST)
+
+$(OBJ)traidio.o : traidio.cc
+	$(CXXCOMPILE) -o $(OBJ)traidio.o traidio.cc
+
+tmtfft : $(EXE)tmtfft
+	echo '---tmtfft made'
+
+$(EXE)tmtfft : $(OBJ)tmtfft.o 
+	$(CXXLINK) -o $(EXE)tmtfft $(OBJ)tmtfft.o $(SOPHYAEXTSLBLIST)
+
+$(OBJ)tmtfft.o : tmtfft.cc
+	$(CXXCOMPILE) -o $(OBJ)tmtfft.o tmtfft.cc
 
 
 ##   -------------- Ex.repertoire Remote ---------
+##    Classes de serveur et client TCP/IP 
+tsok : $(EXE)tsok
+	echo '---tsok made'
 
-tsok : tsok.o  swrapsock.o sockrawstream.o burawstream.o 
-	$(CXXLINK) -o tsok tsok.o  swrapsock.o sockrawstream.o \
-	burawstream.o $(SOPHYASLBLIST)
+$(EXE)tsok : $(OBJ)tsok.o  $(OBJ)swrapsock.o $(OBJ)sockrawstream.o $(OBJ)burawstream.o 
+	$(CXXLINK) -o $(EXE)tsok $(OBJ)tsok.o $(OBJ)swrapsock.o $(OBJ)sockrawstream.o \
+	$(OBJ)burawstream.o $(SOPHYASLBLIST)
 
-tsok.o : tsok.cc swrapsock.h sockrawstream.h  
-	$(CXXCOMPILE) tsok.cc
+$(OBJ)tsok.o : tsok.cc swrapsock.h sockrawstream.h  
+	$(CXXCOMPILE) -o $(OBJ)tsok.o tsok.cc
 
-swrapsock.o : swrapsock.cc swrapsock.h 
-	$(CXXCOMPILE) swrapsock.cc
+$(OBJ)swrapsock.o : swrapsock.cc swrapsock.h 
+	$(CXXCOMPILE) -o $(OBJ)swrapsock.o swrapsock.cc
 
-sockrawstream.o : sockrawstream.cc sockrawstream.h 
-	$(CXXCOMPILE) sockrawstream.cc
+$(OBJ)sockrawstream.o : sockrawstream.cc sockrawstream.h 
+	$(CXXCOMPILE) -o $(OBJ)sockrawstream.o sockrawstream.cc
 
-burawstream.o : burawstream.cc burawstream.h 
-	$(CXXCOMPILE) burawstream.cc
+$(OBJ)burawstream.o : burawstream.cc burawstream.h 
+	$(CXXCOMPILE) -o $(OBJ)burawstream.o burawstream.cc
Index: /trunk/AddOn/TAcq/mcrd.cc
===================================================================
--- /trunk/AddOn/TAcq/mcrd.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/mcrd.cc	(revision 3658)
@@ -170,5 +170,5 @@
          << "  PaqSz=" << paqsz << " NMean=" << NMean << endl;
   }
-  RAcqMemZoneMgr mmgr(NZones, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
+  RAcqMemZoneMgr mmgr(NZones, 1, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
   mmgr.SetFinalizedMask((uint_4)MemZS_ProcA);
 
@@ -226,8 +226,8 @@
          << "  PaqSz=" << paqsz << " NMean=" << NMean << endl;
   }
-  RAcqMemZoneMgr mmgr1(NZones, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
+  RAcqMemZoneMgr mmgr1(NZones, 1, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
   mmgr1.SetFinalizedMask((uint_4)(MemZS_ProcA)|(uint_4)(MemZS_ProcB));
 //  mmgr1.SetFinalizedMask((uint_4)(MemZS_ProcA));
-  RAcqMemZoneMgr mmgr2(NZones, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
+  RAcqMemZoneMgr mmgr2(NZones, 1, NPaqinZone, paqsz, sizeof(complex<r_4>)*paqsz);
   mmgr2.SetFinalizedMask((uint_4)(MemZS_ProcA)|(uint_4)(MemZS_ProcB));
 //  mmgr2.SetFinalizedMask((uint_4)(MemZS_ProcA));
Index: /trunk/AddOn/TAcq/minifits.cc
===================================================================
--- /trunk/AddOn/TAcq/minifits.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/minifits.cc	(revision 3658)
@@ -5,6 +5,50 @@
 // #include <iostream>
 
+//////////////////////////////////////////////////////////////////////
+///     Classe  MiniFITSException
+//////////////////////////////////////////////////////////////////////
+
+
+/* --Methode-- */
+MiniFITSException::MiniFITSException(const char * m)   throw()
+{
+  if (m!=NULL) { 
+    strncpy(msg_, m, MFEX_MAXMSGLEN-1);
+    msg_[MFEX_MAXMSGLEN-1] = '\0';
+  }
+  else msg_[0] = '\0';
+}
+
+/* --Methode-- */
+MiniFITSException::MiniFITSException(const string& m)   throw()
+{
+  strncpy(msg_, m.c_str(), MFEX_MAXMSGLEN-1);
+  msg_[MFEX_MAXMSGLEN-1] = '\0';
+}
+
+/* --Methode-- */
+MiniFITSException::~MiniFITSException()  throw()
+{
+}
+
+/* --Methode-- */
+const char* MiniFITSException::what() const throw()
+{
+  return msg_;
+}
+
+/* --Methode-- */
+string const MiniFITSException::Msg() const 
+{
+  return (string(msg_));
+}
+
+//////////////////////////////////////////////////////////////////////
+///     Classe  MiniFITSFile
+//////////////////////////////////////////////////////////////////////
+
 #define MFITSHLEN 2880
 
+/* --Methode-- */
 MiniFITSFile::MiniFITSFile()
 {
@@ -12,4 +56,5 @@
 }
 
+/* --Methode-- */
 MiniFITSFile::MiniFITSFile(string const & nom, MiniFITS_Mode rwm)
 {
@@ -18,4 +63,5 @@
 }
 
+/* --Methode-- */
 MiniFITSFile::MiniFITSFile(const char* nom, MiniFITS_Mode rwm)
 {
@@ -25,4 +71,5 @@
 
 
+/* --Methode-- */
 MiniFITSFile::~MiniFITSFile()
 {
@@ -31,4 +78,5 @@
 }
 
+/* --Methode-- */
 void MiniFITSFile::Init()
 {
@@ -40,7 +88,9 @@
   totwsz = 0;
   header = new char[MFITSHLEN];
-
-}
-
+  for(int i=0; i<MFITSHLEN; i++)  header[i]=' ';
+  nkeya_ = 0;
+}
+
+/* --Methode-- */
 void MiniFITSFile::Open(const char* nom, MiniFITS_Mode rwm)
 {
@@ -65,4 +115,5 @@
 }
 
+/* --Methode-- */
 void MiniFITSFile::Close()
 {
@@ -71,6 +122,11 @@
   	  // on remplit avec des zeros pour avoir une longueur multiple de 2880	
   	  size_t padsz = MFITSHLEN-(totwsz%MFITSHLEN);
-  	  for(size_t k=0; k<padsz; k++) header[k]=0;
-  	  fwrite(header, 1, padsz, fip);
+          char zeros[160];
+  	  for(size_t k=0; k<160; k++) zeros[k]=0;
+	  while(padsz>160) {
+	    fwrite(zeros, 1, 160, fip);
+	    padsz-=160;
+	  }
+	  if (padsz>0)  fwrite(zeros, 1, padsz, fip);
   	  // On reecrit l'entete 
   	  FillHeader();
@@ -84,4 +140,5 @@
 }
 
+/* --Methode-- */
 void MiniFITSFile::setDTypeNaxis(MiniFITS_DT dt, size_t na1, size_t na2)
 {
@@ -95,4 +152,5 @@
 }
 
+/* --Methode-- */
 string MiniFITSFile::DataTypeToString()
 {
@@ -103,4 +161,5 @@
 }
 
+/* --Methode-- */
 int MiniFITSFile::Write(void* data, size_t sz)
 {
@@ -110,4 +169,5 @@
 }
 
+/* --Methode-- */
 int MiniFITSFile::Read(void* data, size_t sz, size_t offset)
 {
@@ -117,7 +177,7 @@
 }
 
+/* --Methode-- */
 void MiniFITSFile::FillHeader()
 {
-  for(int i=0; i<MFITSHLEN; i++)  header[i]=' ';
   strcpy(header, "SIMPLE  =                    T / file does conform to FITS standard");
   header[strlen(header)] = ' ';
@@ -138,8 +198,8 @@
   sprintf(buff, "NAXIS2  = %20ld /   number of bits per data pixel", (long)nax2);
   buff[strlen(buff)] = ' ';
-  buff = header+400;
+  buff = header+400+nkeya_*80;
   strcpy(buff,"COMMENT  BAO-Radio / MiniFITSFile ");
   buff[strlen(buff)] = ' ';
-  buff = header+480;
+  buff = header+480+nkeya_*80;
   strcpy(buff,"END");
   buff[strlen(buff)] = ' ';
@@ -148,5 +208,76 @@
 }
 
-
+/* --Methode-- */
+int MiniFITSFile::AddKeyI(const char* key, long val, const char* comm)
+{
+  if (nkeya_ >= 29) return 0;
+  char cle[10];
+  strncpy(cle,key,8);
+  cle[8]='=';
+  for(int i=0;i<8;i++) 
+    if (cle[i]=='\0') cle[i]=' ';
+  cle[9]='\0';
+  char* buff=header+400+nkeya_*80;
+  if (comm!=NULL) {
+    char tcom[50];
+    strncpy(tcom,comm,48);  
+    tcom[48]='\0';
+    sprintf(buff,"%s %20ld / %s", cle, val, tcom);
+  }
+  else  sprintf(buff,"%s %20ld / ", cle, val);
+  buff[strlen(buff)]=' ';
+  nkeya_++;
+  return nkeya_;
+}
+
+/* --Methode-- */
+int MiniFITSFile::AddKeyD(const char* key, double val, const char* comm)
+{
+  if (nkeya_ >= 29) return 0;
+  char cle[10];
+  strncpy(cle,key,8);
+  cle[8]='=';
+  for(int i=0;i<8;i++) 
+    if (cle[i]=='\0') cle[i]=' ';
+  cle[9]='\0';
+  char* buff=header+400+nkeya_*80;
+  if (comm!=NULL) {
+    char tcom[50];
+    strncpy(tcom,comm,48);  
+    tcom[48]='\0';
+    sprintf(buff,"%s %20lg / %s", cle, val, tcom);
+  }
+  else  sprintf(buff,"%s %20ld / ", cle, val);
+  buff[strlen(buff)] = ' ';
+  nkeya_++;
+  return nkeya_;
+}
+
+/* --Methode-- */
+int MiniFITSFile::AddKeyS(const char* key, const char* val, const char* comm)
+{
+  if (nkeya_ >= 29) return 0;
+  char cle[10];
+  strncpy(cle,key,8);
+  cle[8]='=';
+  for(int i=0;i<8;i++) 
+    if (cle[i]=='\0') cle[i]=' ';
+  cle[9]='\0';
+  char tcom[72];
+  tcom[0]='\'';
+  strncpy(tcom+1,val,65);
+  int l=strlen(tcom);
+  strcpy(tcom+l,"' / ");
+  l+=4;
+  if ((l<70)&&(comm!=NULL)) strncpy(tcom+l,comm,70-l);
+  tcom[70]='\0';
+  char* buff=header+400+nkeya_*80;
+  sprintf(buff,"%s %s", cle, tcom);
+  buff[strlen(buff)] = ' ';
+  nkeya_++;
+  return nkeya_;
+}
+
+/* --Methode-- */
 void MiniFITSFile::DecodeHeader()
 {
Index: /trunk/AddOn/TAcq/minifits.h
===================================================================
--- /trunk/AddOn/TAcq/minifits.h	(revision 3657)
+++ /trunk/AddOn/TAcq/minifits.h	(revision 3658)
@@ -3,4 +3,5 @@
 
 #include <stdio.h>
+#include <exception>
 #include <string>
 
@@ -14,12 +15,16 @@
 using namespace std;
 
-class MiniFITSException {
+#define MFEX_MAXMSGLEN 160
+
+class MiniFITSException : public std::exception {
   public:
-  explicit MiniFITSException(const char * m) { msg = m; }
-  explicit MiniFITSException(const string& m) { msg = m; }
-  virtual ~MiniFITSException() { } 
-  virtual string const& Msg() const  {return msg;}
+  explicit MiniFITSException(const char * m) throw() ; 
+  explicit MiniFITSException(const string& m) throw() ;
+  virtual ~MiniFITSException() throw() ; 
+    //! Implementation of std::exception what() method, returning the exception message
+  virtual const char* what() const throw();
+  virtual string const Msg() const ; 
  private:
-  string msg;
+  char msg_[MFEX_MAXMSGLEN];
 };
 
@@ -68,4 +73,21 @@
     { return ( Write((void *)data, nel*sizeof(Float32)) ); }
 
+  // Ajout de mots-cle a l'entete FITS
+  int AddKeyI(const char* key, long val, const char* comm=NULL);
+  inline int AddKeyI(string const& key, long val) 
+    { return AddKeyI(key.c_str(), val); }
+  inline int AddKeyI(string const& key, long val, string const& comm) 
+    { return AddKeyI(key.c_str(), val, comm.c_str()); }
+  int AddKeyD(const char* key, double val, const char* comm=NULL);
+  inline int AddKeyD(string const& key, double val) 
+    { return AddKeyD(key.c_str(), val); }
+  inline int AddKeyD(string const& key, double val, string const& comm) 
+    { return AddKeyD(key.c_str(), val, comm.c_str()); }
+  int AddKeyS(const char* key, const char* val, const char* comm=NULL);
+  inline int AddKeyS(string const& key, string const& val) 
+    { return AddKeyS(key.c_str(), val.c_str()); }
+  inline int AddKeyS(string const& key, string const& val, string const& comm) 
+    { return AddKeyS(key.c_str(), val.c_str(), comm.c_str()); }
+
   //  string getKey(string& key);
  protected:
@@ -80,4 +102,5 @@
   size_t totwsz;  // total bytes ecrits
   char* header; //  entete FITS
+  int nkeya_; // 
 };
 
Index: /trunk/AddOn/TAcq/racqumem.cc
===================================================================
--- /trunk/AddOn/TAcq/racqumem.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/racqumem.cc	(revision 3658)
@@ -7,6 +7,20 @@
 
 /* --Methode-- */
-RAcqMemZoneMgr::RAcqMemZoneMgr(uint_4 nz, uint_4 np, uint_4 psz, uint_4 procpsz)
-  : mex(true), nzones(nz), npaq(np), paqsz(psz), procpaqsz(procpsz),stop_(false)
+RAcqMemZoneMgr::RAcqMemZoneMgr(uint_4 nz, uint_4 np, uint_4 psz)
+  : mex(true), nzones(nz), nfibres(1), npaq(np), paqsz(psz), procpaqsz(0), stop_(false), runstate_(MemZR_Running)
+{
+  Init();
+}
+
+/* --Methode-- */
+RAcqMemZoneMgr::RAcqMemZoneMgr(uint_4 nzon, uint_4 nfib, uint_4 npaq, uint_4 paqsz, uint_4 procsz)
+  : mex(true), nzones(nzon), nfibres(nfib), npaq(npaq), paqsz(paqsz), procpaqsz(procsz), 
+    stop_(false), runstate_(MemZR_Running)
+{
+  Init();
+}
+
+/* --Methode-- */
+void RAcqMemZoneMgr::Init()
 {
   St_MemZ st;
@@ -16,8 +30,8 @@
   st.stat = (uint_4)MemZS_Free;
   for(int k=0; k<6; k++) st.nbact[k] = 0;
-  uint_8 mzsz = npaq*paqsz;
-  uint_8 procmzsz = npaq*procpaqsz;
-
-   for(int k=0; k<NbZones(); k++) {
+  uint_8 mzsz = nfibres*npaq*paqsz;
+  uint_8 procmzsz = nfibres*npaq*procpaqsz;
+
+   for(unsigned int k=0; k<NbZones(); k++) {
      memzones.push_back(new Byte[mzsz] );
      states.push_back(st);
@@ -31,5 +45,8 @@
 RAcqMemZoneMgr::~RAcqMemZoneMgr()
 {
-  for(uint_4 k=0; k<NbZones(); k++) delete[] memzones[k]; 
+  for(uint_4 k=0; k<NbZones(); k++) { 
+    delete[] memzones[k]; 
+    if (procpaqsz > 0) delete[] procmemzones[k];
+  }
 }
 
@@ -203,4 +220,5 @@
   //  cout << "RAcqMemZoneMgr::Stop() ........ STOP                          BROADCAST" <<endl; 
   stop_ = true;
+  runstate_ = MemZR_Stopped;
   mex.broadcast();
 }
Index: /trunk/AddOn/TAcq/racqumem.h
===================================================================
--- /trunk/AddOn/TAcq/racqumem.h	(revision 3657)
+++ /trunk/AddOn/TAcq/racqumem.h	(revision 3658)
@@ -31,4 +31,5 @@
 } St_MemZ;
 
+
 // Les flags (bits) correspondant aux operations effectuees sur une zone
 // Free->libre, Filled->rempli(par DMA), Saved(ecrit sur disque), Proc(Traitement)
@@ -39,4 +40,13 @@
 enum MemZaction { MemZA_None=0, MemZA_Fill=1, MemZA_Save=2, MemZA_Proc=4, 
                   MemZA_ProcA=8, MemZA_ProcB=16, MemZA_ProcC=32 };
+
+// configuration du RAcqMemZoneMgr 
+enum MemZconfig { MemZConf_SingleFiberDataOnly=0, MemZConf_MultiFiberDataOnly=1,
+                  MemZConf_SingleFiberProcDataOnly=2, MemZConf_MultiFiberProcDataOnly=3,
+                  MemZConf_SingleFiberDataAndProcData=4, MemZConf_MultiFiberDataAndProcData=5 };
+// L'etat d'execution en cours : running, waiting, stopped
+enum MemZRunState { MemZR_Running=0, MemZR_Waiting=1, MemZR_Stopped=2};
+
+
 
 // -------------------------------------------------------------------
@@ -49,9 +59,16 @@
 //     Si procpsz>0 , on alloue aussi des zones memoire pour donnees traitees
 //      dans ce cas, procpsz à la taille memoire des donnees traites pour chaque paquet 
-  RAcqMemZoneMgr(uint_4 nz, uint_4 np=256, uint_4 psz=4096, uint_4 procpsz=0);
+// Constructeur 1 : l'objet ne contient que les donnees d'une fibre 
+//                  garde pour maintenir la compatibilite avec version TAcq v <= 6.0 
+  RAcqMemZoneMgr(uint_4 nz, uint_4 np, uint_4 psz);
+// Constructeur 2 : l'objet peut contenir plusieurs fibres, et des donnees processes en plus
+  RAcqMemZoneMgr(uint_4 nzon, uint_4 nfib, uint_4 npaq, uint_4 paqsz, uint_4 procsz=0);
+
   ~RAcqMemZoneMgr();
   
+  // Retourne le nombre de fibres dans chaque zone
+  inline uint_4 NbZones() { return nzones; }
   // Retourne le nombre de zones memoire
-  inline uint_4 NbZones() { return nzones; }
+  inline uint_4 NbFibres() { return nfibres; }
   // Retourne la taille de paquet
   inline uint_4 PaqSize() { return paqsz; }
@@ -59,11 +76,13 @@
   inline uint_4 NbPaquets() { return npaq; }
   // Retourne la taille totale d'une zone 
-  inline uint_4 ZoneSize() { return npaq*paqsz; }
+  inline uint_4 ZoneSize() { return nfibres*npaq*paqsz; }
+  inline uint_4 OneFiberZoneSize() { return npaq*paqsz; }
 
   // Retourne la taille de la zone memoire correspondant aux donnees traitees d'un paquet
   inline uint_4 ProcPaqSize() { return procpaqsz; }
   // Retourne la taille totale d'une zone de donnees traitees
-  inline uint_4 ProcZoneSize() { return npaq*procpaqsz; }
-  
+  inline uint_4 ProcZoneSize() { return nfibres*npaq*procpaqsz; }
+  inline uint_4 OneFiberProcZoneSize() { return npaq*procpaqsz; }
+
   // Definit l'etat des operations obligatoires avant qu'une zone 
   // remplie ne puisse etre recyclee (re-remplie)
@@ -76,9 +95,23 @@
   // Libere une zone memoire en marquant son etat
   int FreeMemZone(int id, MemZStatus st);
-  // Retourne le pointeur de la zone numero k
+  // Retourne le pointeur de la zone numero k pour les datas
+
+  // Retourne le pointeur de la zone numero k pour les datas pour une fibre donnee
+  inline Byte* GetMemZone(int id, int fib)  {
+    if ((id < 0) || (id >=(int) memzones.size()))  return NULL;
+    if ((fib < 0) || (fib >=(int) nfibres))  return NULL;
+    return memzones[id]+fib*OneFiberZoneSize();  
+    }
+  // Retourne le pointeur de la zone numero k pour les resultats de traitement pour une fibre donnee
+  inline Byte* GetProcMemZone(int id, int fib)  {
+    if ((id < 0) || (id >=(int) procmemzones.size()))  return NULL;
+    return procmemzones[id]+fib*OneFiberProcZoneSize();  
+    }
+  // Retourne le pointeur de la zone numero k pour les datas
   inline Byte* GetMemZone(int id)  {
     if ((id < 0) || (id >=(int) memzones.size()))  return NULL;
     return memzones[id];  
     }
+  // Retourne le pointeur de la zone numero k pour les resultats de traitement
   inline Byte* GetProcMemZone(int id)  {
     if ((id < 0) || (id >=(int) procmemzones.size()))  return NULL;
@@ -87,10 +120,17 @@
   
   ostream& Print(ostream& os);
+
   void Stop(); 
-        
+  inline MemZRunState GetRunState() 
+    { return runstate_; }
+  inline MemZRunState ChangeRunState( MemZRunState st) 
+    { runstate_ = st; return runstate_; }
+
 protected:
+  void Init();  // Fait l'allocation des differents buffers - est appele par les constructeurs
+
   // ... variables membres
   ZMutex mex;   
-  uint_4 nzones, npaq, paqsz, procpaqsz;
+  uint_4  nzones, nfibres, npaq, paqsz, procpaqsz;
 //  DMAMgrInterface &dma_;
   vector< Byte* > memzones;
@@ -98,4 +138,5 @@
   vector< Byte* > procmemzones;
   bool stop_;
+  MemZRunState runstate_;
   uint_4 mask_finalized_;
   uint_8 serial_;  
Index: /trunk/AddOn/TAcq/racqurw.cc
===================================================================
--- /trunk/AddOn/TAcq/racqurw.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/racqurw.cc	(revision 3658)
@@ -59,6 +59,4 @@
 void PCIEReader::run()
 {
-  struct sigaction act;
-  struct sigaction old_act;
    //Precision insuffisante  ResourceUsage ru; ru.Update();  // Pour recuperer le temps passe
   struct timeval tv1, tv2;
@@ -70,5 +68,5 @@
   setRC(1);	
 
-  uint_4 cpt=0;
+ 
   // sigaddset(&act.sa_mask,SIGINT);  // pour proteger le transfert DMA
   //sigaction(SIGINT,&act,NULL);  
@@ -232,4 +230,5 @@
     uint_4 fnum=0;
     uint_4 paqsz = memgr.PaqSize();
+    cout << " ============================ DataSaver::run() PaqSize " << paqsz <<endl;
     bool fgnulldev = false;
     if (path_ == "/dev/null") { 
@@ -253,4 +252,5 @@
         // Entete correspondant a l'ecriture tout le paquet - trailer compris (modif Mai 2009)
         mff.setDTypeNaxis(MF_Byte, paq0.PaquetSize(), npaqperfile);
+
         // Sans TRAILER de paquet mff.setDTypeNaxis(MF_Byte, paq0.DataSize()+paq0.HeaderSize(), npaqperfile); 
       }
@@ -353,5 +353,5 @@
   cout << " ... RAcqMemZoneMgr not used - using s fixed memory location for packets decoding ..." << endl;
 
-  uint_4 cpt=0;
+ 
   // sigaddset(&act.sa_mask,SIGINT);  // pour proteger le transfert DMA
   //sigaction(SIGINT,&act,NULL);  	
@@ -363,5 +363,5 @@
 
   Byte* Datas = NULL;
-  Byte* locdata = new Byte[paqsz];
+  Byte* locdata = new Byte[paqsz*memgr.NbPaquets()*memgr.NbZones()];
   Byte* tampon = new Byte[paqsz];
 
@@ -375,5 +375,5 @@
     if (fgarret) break;
 
-    Byte* nextdma = locdata;
+    Byte* nextdma = locdata+((kmz%memgr.NbZones())*(paqsz*memgr.NbPaquets()));
     uint_4 npaqfait = 0;      
     //      for (uint_4 i=0; i<memgr.NbPaquets(); i += pktInDMATr) {  // attention pktInDMATr paquets dans 1 seul DMA
@@ -419,5 +419,6 @@
 	  while((curoff+paqsz)<=dmasz) {
 	    //	      BRPaquet paq((Byte*)(Datas)+((paqsz*j)), nextdma+j*paqsz, paqsz, swapall_);
-	    BRPaquet paq(Datas+curoff, locdata, paqsz, swapall_);
+	    //  BRPaquet paq(Datas+curoff, locdata, paqsz, swapall_);
+	    BRPaquet paq(Datas+curoff, nextdma+npaqfait*paqsz, paqsz, swapall_);
 	    curoff += paqsz;  // On avance l'index dans le buffer du DMA
 	    npaqfait++;  // Ne pas oublier le compteur de paquets faits 
@@ -457,2 +458,376 @@
 
 }
+////////////////////////////////////////////////////////////////////////////////////////////////////////
+//----------------------------------------------------------------------------------------------------------
+// Classe thread de lecture PCI-Express + Check pour tests de verification de debit/etc avec un seul thread
+//----------------------------------------------------------------------------------------------------------
+
+/* --Methode-- */
+PCIEMultiReader::PCIEMultiReader(vector<PCIEWrapperInterface*> vec_pciw,uint_4 sizeFrame,uint_4 packSize ,RAcqMemZoneMgr& mem, uint_4 nmax, BRDataFmtConv swapall,int binMin, int nbBin)
+  :   memgr(mem) , vec_pciw_ (vec_pciw)
+{
+  nmax_ = nmax;	
+  swapall_ = swapall;  	// select data swap/format conversion for BRPaquet
+  stop_ = false;
+  packSize_ = packSize;
+  packSizeInMgr_=memgr.PaqSize();
+  sizeFr_ =sizeFrame;
+  binMin_= binMin;
+  nbBin_= nbBin;
+  if (vec_pciw.size() != memgr.NbFibres()) {
+    cout << " PCIEMultiReader()PbArgs: vec_pciw.size()= " << vec_pciw.size() << " memgr.NbFibres()=" <<memgr.NbFibres()<< endl;
+    throw ParmError("PCIEMultiReader:ERROR/ arguments incompatibles vec_pciw.size() != memgr.NbFibres() ");
+  }
+  if (vec_pciw.size() > MAXNBFIB) 
+    throw ParmError("PCIEMultiReader:ERROR/  vec_pciw.size() > MAXNBFIB ");
+  nbDma_= vec_pciw.size();
+  mid_=-2; 
+  mmbuf_=NULL;
+  max_targ_npaq = memgr.NbPaquets();
+  for (int fid=0 ; fid<(int)nbDma_ ;fid++) mmbufib_[fid]=NULL;
+}
+
+/* --Methode-- */
+void PCIEMultiReader::run()
+{
+  
+  struct timeval tv1,tv2;
+  gettimeofday(&tv1, NULL);
+  
+  cout << " PCIEMultiReader::run() - Starting , NMaxMemZones=" << nmax_ 
+       << " memgr.NbPaquets()=" << memgr.NbPaquets() << "Paqsize " << packSize_<< endl;	
+  setRC(1);	
+
+  // sigaddset(&act.sa_mask,SIGINT);  // pour proteger le transfert DMA
+  //sigaction(SIGINT,&act,NULL);  	
+  // uint_4 paqsz = memgr[0]->PaqSize();
+  uint_4 paqsz =  packSize_;
+  uint_4 dmasz = vec_pciw_[0]->TransferSize();
+  vec_pciw_[0]->StartTransfers();
+
+  BRPaqChecker pcheck[MAXNBFIB];  // Verification/comptage des paquets  
+  Byte* Datas[MAXNBFIB];
+  Byte* tampon[MAXNBFIB] ; 
+  Byte* nextpaq=NULL;
+  uint_4 off_acheval=0;
+  
+  int nerrdma = 0;
+  int maxerrdma = 10;
+  bool fgarret = false;
+  
+  // Initialisation des tampons pour recopie des paquets a cheval pour chaque DMA
+  for (int i=0;i< (int)nbDma_ ;i++) {  
+    tampon[i]=   new Byte[paqsz];
+  }
+ 
+  ofstream header[MAXNBFIB];
+  for(uint_4 fib=0; fib<nbDma_; fib++) {
+    char hfnm[128];
+    sprintf(hfnm, "./HDRCountPaqs%d.txt", fib);
+    header[fib].open(hfnm);
+  }
+   
+  uint_4 npaqfait[MAXNBFIB] ;
+  for (int i=0;i< (int)nbDma_ ;i++) npaqfait[i]=0;
+    // Byte* nextdma = locdata+((kmz%memgr.NbZones())*(paqsz*memgr.NbPaquets()));
+  uint_4 npaqfaitg = 0;      
+  //      for (uint_4 i=0; i<memgr.NbPaquets(); i += pktInDMATr) {  // attention pktInDMATr paquets dans 1 seul DMA
+  while (npaqfaitg < nmax_*memgr.NbPaquets()) {  // Boucle global G 
+    if (fgarret) break;
+    if (stop_) break;
+    
+    // Lancement des DMA 
+    for (int dma=0; dma < (int)nbDma_ ;dma++) vec_pciw_[dma]->StartTransfers();
+    
+    // On pointe vers le debut de la zone a remplir aver le prochain DMA
+    //-- Zone memoire locale Byte* nextdma = buff+i*paqsz;
+    
+    bool fgbaddma=false;
+    // On boucle sur les nbDma_ en attente de leurs terminaison    
+    for (int dma=0; dma <(int) nbDma_ ;dma++)  {
+      Datas[dma]=vec_pciw_[dma]->GetData();
+      if (Datas[dma] == NULL) { // No data Read in DMA 
+	nerrdma ++;   fgbaddma=true;
+	cout << "PCIEMultiReaderChecker/Erreur Waiting for datas ..." << endl;
+	vec_pciw_[dma]->PrintStatus(cout);
+	if (nerrdma>=maxerrdma) { fgarret = true; break; }
+      }
+    }
+    if (fgbaddma) continue;  
+    uint_4 curoff=0;
+    //1- On traite le paquet a cheval, rempli partiellement avec le DMA d'avant si necessaire pour les n fibres
+    if (off_acheval  > 0) {  // IF Numero B
+      if ((paqsz-off_acheval)< dmasz) {  // IF Numero A
+	for(uint_4 fib=0; fib<nbDma_; fib++) 
+	  memcpy((void *)((tampon[fib])+off_acheval), (void *)Datas[fib], paqsz-off_acheval);
+	curoff = paqsz-off_acheval;  off_acheval = 0;
+	if ( MoveToNextTarget() ) {
+	  cout << "PCIEMultiReader::run()/Error-A- MoveToNextTarget() returned true ->STOP 9" << endl;
+	  setRC(9);  fgarret=true; break;
+	}
+	for(uint_4 fib=0; fib<nbDma_; fib++) {
+	  nextpaq=GetPaquetTarget(fib);
+	  if (nextpaq == NULL) { // Cela ne devrait pas arriver 
+	    cout << "PCIEReader::run()/Error-A2- GetPaquetTarget(fib)  returned NULL ->STOP 9" << endl;
+	    setRC(9);  fgarret=true; break;
+	  }
+	  BRPaquet paq(tampon[fib], nextpaq, paqsz, swapall_,binMin_,nbBin_);
+	  npaqfait[fib]++;
+	  if (fib==nbDma_-1) npaqfaitg++;  // Ne pas oublier le compteur de paquets faits 
+	  pcheck[fib].Check(paq);   // Verification du paquet / FrameCounter 
+	  header[fib] << dec << paq.FrameCounter()<< endl; ;
+	}
+      }
+      else {  // se rapporte au IF numero A
+	for(uint_4 fib=0; fib<nbDma_; fib++) 
+	  memcpy((void *)(tampon[fib]+off_acheval), (void *)Datas[fib], dmasz);
+	curoff =dmasz;
+	off_acheval = (dmasz+off_acheval);
+      } 
+    }  // Fin IF Numero B
+
+    //2- On traite les paquets complets qui se trouvent dans la zone du DMA 
+    while ((curoff+paqsz)<=dmasz) {  // while numero C 
+      //	  if ((dma==nbDma_-1)&&(npaqfait >= nmax_* memgr.NbPaquets())) break;
+      if ( MoveToNextTarget() ) {
+	cout << "PCIEMultiReader::run()/Error-B- MoveToNextTarget() returned true ->STOP 9" << endl;
+	setRC(9);  fgarret=true; break;
+      }
+      for(uint_4 fib=0; fib<nbDma_; fib++) {
+	if (npaqfait[fib] >= nmax_*memgr.NbPaquets())  continue;
+	nextpaq=GetPaquetTarget(fib);
+	if (nextpaq == NULL) { // Cela ne devrait pas arriver 
+	  cout << "PCIEReader::run()/Error-B2- GetPaquetTarget(fib)  returned NULL ->STOP 9" << endl;
+	  setRC(9);  fgarret=true; break;
+	}
+	BRPaquet paq(Datas[fib]+curoff, nextpaq, paqsz, swapall_,binMin_,nbBin_);
+	npaqfait[fib]++;
+	if (fib==nbDma_-1) npaqfaitg++;  // Ne pas oublier le compteur de paquets faits 
+	pcheck[fib].Check(paq);   // Verification du paquet / FrameCounter 
+	header[fib] << dec << paq.FrameCounter()<< endl; ;
+      }
+      curoff += paqsz;  // On avance l'index dans le buffer du DMA
+    } // -- FIN traitement des paquets complets ds un DMA - FIN du while numero C 
+      //3- On copie si besoin la fin du DMA dans la zone tampon
+    if (curoff < dmasz) {  // IF numero D 
+      off_acheval = dmasz-curoff;
+      for(uint_4 fib=0; fib<nbDma_; fib++) 
+	memcpy(tampon[fib], (void*)(Datas[fib]+curoff), off_acheval);
+      // ne sert a rien 	curoff += off_acheval; 
+    } // FIN du if numero D 
+  }  //   FIN  Boucle global G 
+
+    
+  setRC(0);
+  gettimeofday(&tv2, NULL);
+  double tmelaps2 = (tv2.tv_sec-tv1.tv_sec)*1000.+(tv2.tv_usec-tv1.tv_usec)/1000.;
+  if (tmelaps2<0.1) tmelaps2=0.1; 
+  cout << " ---------- PCIEMultiReader::run()-End summary NPaqFait=" << npaqfaitg << "------------- " << endl;
+  for (int dma=0; dma < (int)nbDma_ ;dma++)   {
+    cout << " --Fib=" << dma << " NPaqFait=" << npaqfait[dma] <<  " TotTransfer=" 
+	 << vec_pciw_[dma]->TotTransferBytes()/1024 
+	 << " kb , ElapsTime=" << tmelaps2 << " ms ->" 
+	 << (double)vec_pciw_[dma]->TotTransferBytes()/tmelaps2 << " kb/s" << endl;	
+    pcheck[dma].Print(cout);
+  }
+  cout << " --------------------------------------------------------------------" << endl;
+
+  // //// Nettoyage final
+  MZoneManage(true);
+  for(uint_4 fib=0; fib<nbDma_; fib++)  header[fib].close();
+  for (int i=0;i< (int)nbDma_ ;i++) delete[] tampon[i]; 
+  //DBG  cout << " fin thread ========================" <<endl;  
+  return;
+}
+
+/* --Methode-- */
+bool PCIEMultiReader::MZoneManage(bool fgclean)    // Retourne true si probleme 
+{
+  /* Pour debug 
+  cout << " PCIEReader::MZoneManage() mid_=" << mid_ << " arg_npaq_= " << targ_npaq_  
+       << " max_targ_npaq=" << max_targ_npaq << endl;
+  */
+  if (mid_ >= 0)  memgr.FreeMemZone(mid_, MemZS_Filled);
+  mmbuf_ = NULL;  targ_npaq_ = 0;  mid_ = -2;
+  for (int fid=0;fid<(int)nbDma_ ;fid++) mmbufib_[fid]=NULL;
+  if (fgclean)  return false;
+  mid_ = memgr.FindMemZoneId(MemZA_Fill);
+  mmbuf_ = memgr.GetMemZone(mid_);
+  if (mmbuf_==NULL)   return true;
+  for (int fid=0;fid<(int)nbDma_ ;fid++) mmbufib_[fid]=memgr.GetMemZone(mid_,fid);
+  return false;
+}
+
+/*
+bool PCIEMultiReader::MZoneManage(int zone,bool fgclean)    // Retourne true si probleme 
+{
+  // Pour debug 
+  //cout << " PCIEReader::MZoneManage() mid_=" << mid_ << " arg_npaq_= " << targ_npaq_  
+       << " max_targ_npaq=" << max_targ_npaq << endl;
+  if (mid_[zone] >= 0)  memgr[zone]->FreeMemZone(mid_[zone], MemZS_Filled);
+  mmbuf_[zone] = NULL;  targ_npaq_[zone] = 0;  mid_[zone] = -2;
+  if (fgclean)  return false;
+  mid_[zone] = memgr[zone]->FindMemZoneId(MemZA_Fill);
+  mmbuf_[zone] = memgr[zone]->GetMemZone(mid_[zone]);
+  if (mmbuf_[zone]==NULL) return true;
+  return false;
+}
+*/
+
+/* --Methode-- */
+void PCIEMultiReader::Stop()
+{ 
+  // cout << " PCIEReaderChecker::stop()  ........ STOP" <<endl; 
+  stop_ = true;
+
+}
+
+
+//--------------------------------------------------------------------
+// Classe thread de sauvegarde sur fichiers avec gestion multifibres 
+//--------------------------------------------------------------------
+
+MultiDataSaver::MultiDataSaver(RAcqMemZoneMgr& mem, string& path, uint_4 nfiles, uint_4 nblocperfile, bool savesig)
+  :  memgr(mem) 
+{
+  nfiles_ = nfiles;
+  nblocperfile_ = nblocperfile;
+  nmax_ = nblocperfile_*nfiles_;
+  savesig_ = savesig;  // Si false, pas d'ecriture des fichiers FITS du signal	
+  stop_ = false;	
+  path_ = path;	
+}
+void MultiDataSaver::Stop()
+{
+  // cout<< " MultiDataSaver:Stop ........ " << endl;
+  stop_=true;
+
+}
+void MultiDataSaver::run()
+{
+  setRC(1);	
+  BRPaqChecker pcheck[MAXNBFIB];  // Verification/comptage des paquets 
+
+  try {
+    TimeStamp ts; 
+    cout << " MultiDataSaver::run() - Starting " << ts << " \n   NbFiles=" << nfiles_ << " NBloc/File=" 
+         << nblocperfile_ << " NMaxMemZones=" << nmax_ << endl;	
+    char fname[512];
+
+    sprintf(fname,"%s/msaver.log",path_.c_str());
+    ofstream filog(fname);
+    filog << " MultiDataSaver::run() - starting log file " << ts << " NFibres= " << memgr.NbFibres() << endl;		       
+    filog << " NbFiles=" << nfiles_ << " NBloc/File="  << nblocperfile_ << " NMaxMemZones=" << nmax_ << endl;
+    	
+    // Fichiers entete ascii et signal FITS
+    ofstream header[MAXNBFIB];
+    MiniFITSFile mff[MAXNBFIB]; 
+
+    uint_4 fnum=0;
+    uint_4 paqsz = memgr.PaqSize();
+    cout << " ============================ MultiDataSaver::run() PaqSize " << paqsz <<endl;
+    bool fgnulldev = false;
+    if (path_ == "/dev/null") { 
+      cout << " MultiDataSaver::run()/Warning /dev/null path specified, filenames=/dev/null" << endl;
+      fgnulldev = true;
+    }
+    for (uint_4 nbFile=0;nbFile<nfiles_ ;nbFile++) {
+      if (stop_ )   break;
+      if (memgr.GetRunState() == MemZR_Stopped) break;
+
+      if (savesig_)
+	for(uint_4 fib=0; fib<memgr.NbFibres(); fib++) {
+	  if (fgnulldev) strcpy(fname,"/dev/null");
+	  else sprintf(fname,"%s/Fibre%d/HDRfits%d.txt",path_.c_str(),fib+1,fnum);
+	  header[fib].open(fname);
+	}
+      BRPaquet paq0(NULL, NULL, paqsz); 
+      uint_4 npaqperfile = memgr.NbPaquets()*nblocperfile_;  // Nombre de paquets ecrits dans un fichier 
+
+      if (savesig_) { //Reza - Ouverture conditionnel fichier 
+        for(uint_4 fib=0; fib<memgr.NbFibres(); fib++) {
+	  if (fgnulldev) strcpy(fname,"/dev/null");
+	  else sprintf(fname,"%s/Fibre%d/signal%d.fits",path_.c_str(),fib+1,(int)fnum);
+	  mff[fib].Open(fname,MF_Write);  //Reza - Ouverture conditionnel fichier 
+	  // Entete correspondant a l'ecriture tout le paquet - trailer compris (modif Mai 2009)
+	  mff[fib].setDTypeNaxis(MF_Byte, paq0.PaquetSize(), npaqperfile);
+	}
+	fnum++;
+        // Sans TRAILER de paquet mff.setDTypeNaxis(MF_Byte, paq0.DataSize()+paq0.HeaderSize(), npaqperfile); 
+      }
+      else sprintf(fname,"MemDataBloc[%d]-NoDataFile",(int)fnum++);
+
+      for (uint_4 kmz=0; kmz<nblocperfile_; kmz++) {
+	if (stop_) break;
+	  //DBG cout << " MultiDataSaver::run()- nbFile=" << nbFile << " kmz=" << kmz << endl;	
+	int mid = memgr.FindMemZoneId(MemZA_Save);  
+	Byte* buffg = memgr.GetMemZone(mid);
+        if (buffg == NULL) {
+	  cout << " MultiDataSaver::run()/ERROR memgr.GetMemZone(" << mid << ") -> NULL" << endl;
+	  setRC(2);	
+	  return;	
+	}
+	for(uint_4 fib=0; fib<memgr.NbFibres(); fib++)  {  // Boucle sur les fibres 
+	  Byte* buff = memgr.GetMemZone(mid,fib);
+	  if (buff == NULL) {  // Ceci ne devrait pas arriver - suite au test buffg ci-dessus
+	    cout << " MultiDataSaver::run()/ERROR memgr.GetMemZone(" << mid << "," << fib << ") -> NULL" << endl;
+	    setRC(2);	
+	    return;	
+	  }
+	  for(uint_4 i=0; i<memgr.NbPaquets(); i++) {  // boucle sur les paquets 
+	    BRPaquet paq(NULL, buff+i*paqsz, paqsz);
+	    pcheck[fib].Check(paq);   // Verification du paquet / FrameCounter 
+	    if (savesig_)
+	      header[fib] << hex << paq.HDRMarker() << " " << paq.TRLMarker() << " " 
+			  << paq.TimeTag2()<< " "<< paq.TimeTag1()<< " " 
+			  << paq.FrameCounter() << " " << paq.PaqLen()  << endl;
+	    if (savesig_) // Reza - Ecriture conditionnel fichier fits signal 
+	      mff[fib].WriteB(paq.Header(),paq.PaquetSize()); // ecriture tout le paquet (modif Mai 2009)
+	  } // Fin de la boucle sur les paquets 
+	}  // Fin de la boucle sur les fibres 
+	memgr.FreeMemZone(mid, MemZS_Saved);
+      }  // Boucle sur les blocs dans un meme fichier
+      ts.SetNow(); 
+      filog << ts << " : OK data files " << endl;
+      cout << " MultiDataSaver::run() " << ts << " : OK data files  " << endl;
+      for(uint_4 fib=0; fib<memgr.NbFibres(); fib++) {
+	if (savesig_) {
+	  if (fgnulldev) strcpy(fname,"/dev/null");
+	  else sprintf(fname,"%s/Fibre%d/signal%d.fits",path_.c_str(),fib+1,(int)fnum-1);
+	}
+	else sprintf(fname,"MemDataBloc[%d]-NoDataFile",(int)fnum-1);
+        filog << "    Fib " << fib << " -> " << fname << endl;
+        cout << "    Fib " << fib << " -> " << fname << endl;
+      }
+      if (savesig_)
+	for(uint_4 fib=0; fib<memgr.NbFibres(); fib++) {
+          header[fib].close();
+          mff[fib].Close();	  
+	}
+    }  // Fin de boucle sur les fichiers 
+    cout << " --------------------  MultiDataSaver::run() -------------------- " << endl;
+    for(uint_4 fib=0; fib<memgr.NbFibres(); fib++) {
+      cout << " MultiDataSaver/Summary Fib " << fib << endl;
+      pcheck[fib].Print(cout);
+      filog << " MultiDataSaver/Summary Fib " << fib << endl;
+      pcheck[fib].Print(filog);
+    }
+    cout << " ---------------------------------------------------------- " << endl;
+    ts.SetNow();
+    filog << " MultiDataSaver::run() - End of processing/run() " << ts << endl;		       
+
+  }
+  catch (MiniFITSException& exc) {
+    cout << " MultiDataSaver::run()/catched MiniFITSException " << exc.Msg() << endl;
+    setRC(3);	
+    return; 
+  }
+  catch(...) {
+    cout << " MultiDataSaver::run()/catched unknown ... exception " << endl;
+    setRC(4);	
+    return; 
+  }
+  setRC(0);
+  return;
+}   
+
Index: /trunk/AddOn/TAcq/racqurw.h
===================================================================
--- /trunk/AddOn/TAcq/racqurw.h	(revision 3657)
+++ /trunk/AddOn/TAcq/racqurw.h	(revision 3658)
@@ -22,4 +22,7 @@
 
 
+// Quelques definitions globales
+// Nombre maximum de fibres geres par les classes MultiReader / MultiDiskWriter
+#define MAXNBFIB  4   
 
 //-------------------------------------------------------
@@ -89,5 +92,5 @@
 class PCIEReaderChecker : public ZThread {
 public:
-  PCIEReaderChecker( PCIEWrapperInterface &pciw , uint_4 sizeFrame,uint_4 paqSize ,RAcqMemZoneMgr& mem, 
+  PCIEReaderChecker( PCIEWrapperInterface &pciw , uint_4 sizeFrame,uint_4 paqSize, RAcqMemZoneMgr& mem, 
 		     uint_4 nmax=100, BRDataFmtConv swapall=BR_SwapAll);  
   virtual void run(); 
@@ -103,4 +106,74 @@
   uint_4 packSize_;
 };
+//------------------------------------------------------------------
+// Classe thread de lecture PCI-Express multi fibre (ou multi DMA)
+//------------------------------------------------------------------
+
+class PCIEMultiReader : public ZThread {
+public:
+  PCIEMultiReader( vector<PCIEWrapperInterface*> vec_pciw , uint_4 sizeFrame,uint_4 paqSize, RAcqMemZoneMgr& mem, 
+		   uint_4 nmax=100, BRDataFmtConv swapall=BR_SwapAll,int binMin=0, int nbBin=0);  
+  virtual void run(); 
+   void Stop();
+  inline void STOP() { stop_ = true; }	
+
+protected: 
+  // Permet d'avancer d'un paquet dans la zone - renvoie true si probleme
+  inline bool MoveToNextTarget()  {
+    if ((mmbuf_ == NULL )||(targ_npaq_ >= max_targ_npaq)) 
+      if (MZoneManage()) return true;
+    targ_npaq_++;
+    return false;
+  }
+  inline Byte* GetPaquetTarget(int numfib)  {
+    if ((mmbufib_[numfib] == NULL )||(targ_npaq_ > max_targ_npaq)||(targ_npaq_ == 0))  return NULL; 
+    Byte* rb=mmbufib_[numfib]+(targ_npaq_-1)*packSizeInMgr_;
+    return rb;
+  }
+  bool MZoneManage(bool clean=false);  // Renvoie true si probleme
+
+  RAcqMemZoneMgr& memgr;
+  uint_4 nmax_;  // Nombre maxi de blocs MemZone traites
+  BRDataFmtConv swapall_;  // select data swap/format conversion for BRPaquet
+  bool stop_;  
+  unsigned int sizeFr_ ;
+  vector<PCIEWrapperInterface *> vec_pciw_;
+  uint_4 packSize_;
+  uint_4 packSizeInMgr_;
+  uint_4 nbDma_;
+  int nbBin_;
+  int binMin_;
+  int mid_;  // Identificateur zone memoire
+  uint_4 targ_npaq_;  // Numero de paquet dans une seule zone memoire 
+  uint_4 max_targ_npaq; // =  mmgr.NbPaquets() = Max de targ_npaq_
+  Byte* mmbuf_;  // Pointeur zone memoire rendu par RAcqMemZoneMgr 
+  Byte* mmbufib_[MAXNBFIB];  // Pointeurs zone memoire de chaque fibre rendu par RAcqMemZoneMgr 
+
+};
+
+
+
+//----------------------------------------------------------------------------------------
+// Classe thread de sauvegarde sur fichiers - gerant plusieurs fibres dans RAcqMemZoneMgr
+//----------------------------------------------------------------------------------------
+
+class MultiDataSaver : public ZThread {
+public:	
+  MultiDataSaver(RAcqMemZoneMgr& mem, string& path, uint_4 nfiles=100, uint_4 nblocperfile=1, bool savesig=true);
+
+  virtual void run(); 
+  void Stop(); 
+  inline void STOP() { stop_ = true; }	
+protected:
+  RAcqMemZoneMgr& memgr;
+  uint_4 nfiles_;  // Nombre maxi de fichiers cree
+  uint_4 nblocperfile_;  // Nombre de bloc (zone memoire) mis dans un fichier
+  uint_4 nmax_;  // Nombre maxi de blocs MemZone traites = nfiles * nblocperfile_
+  bool savesig_; // Si false, pas d'ecriture des fichiers FITS du signal 
+  bool stop_;  
+  string path_;  
+  struct sigaction act;
+ 
+};
 
 #endif
Index: /trunk/AddOn/TAcq/tstminifits.cc
===================================================================
--- /trunk/AddOn/TAcq/tstminifits.cc	(revision 3657)
+++ /trunk/AddOn/TAcq/tstminifits.cc	(revision 3658)
@@ -58,4 +58,12 @@
     mff.setDTypeNaxis(MF_Float32, sx, sy);
     mff.Open("tmf.fits", MF_Write);
+    // Exemple d'ajout d'information dans l'entete FITS
+    mff.AddKeyI("CleI_A", 12);
+    mff.AddKeyD("CleD_B", 3.1415, " Valeur de Pi");
+    mff.AddKeyS("CleS_C", "Prog. tstminifits", " Cle de type string");
+    // Ajout de date-heure dans l'entete FITS
+    TimeStamp tsc;
+    string cdtu=tsc.ToString();
+    mff.AddKeyS("DATEOBS", cdtu.c_str(), " Observation Time (YYYY-MM-DDThh:mm:ss UT) ");
     mff.WriteI(ta.Data(), sx*sy);
     }
@@ -65,4 +73,7 @@
     mff.setDTypeNaxis(MF_Int16, sx, sy);
     mff.Open("tmf2.fits", MF_Write);
+    TimeStamp tsc;
+    string cdtu=tsc.ToString();
+    mff.AddKeyS("DATE", cdtu.c_str(), " File Creation time(YYYY-MM-DDThh:mm:ss UT) ");
     mff.WriteF(arr.Data(), sx*sy);
     }
